#
#    Setup program for Example 4.1: Randomized block design
#
#    Calculates various matrices needed for calculations 
#    of AIC, etc and REML
#
#     ===============================================
#
#     Compute matrices for AIC, etc
#
#     Compute XpB = [ X : BigB ]
#
B <- bspline(x, xl, xr, ndx, bdeg)
BigB <- dbind(list(B, B, B))
XpB <- cbind(X, BigB)
#
#     Compute D-penalty matrix for block design and augment it
#
D <- diag( ncol(B) )
for (k in 1:pord) D <- diff(D)
DtD <- t(D) %*% D
BigDtD <- dbind(list(DtD, DtD, DtD))
BigDtD <- Augment(X, BigDtD)
#
#    ==================================================
#
#    Compute matrices for REML
#
#    Find Z = D'(DD')^{-1}, B and G 
#
Z <- t(D) %*% solve(D %*% t(D))
G <- matrix(1, nrow = ncol(B), ncol = 1)
if (pord==1) G <- G else for (i in 1:(pord-1)) G <- cbind(G,(1:nrow(G))^i)
#
#    Common lambda: compute bigX and diag(BZ)
#
BG <- B %*% G
bigX <- cbind( X, dbind(list(BG, BG, BG)) )
BZ <- B %*% Z
bigBZ <- dbind(list(BZ, BZ, BZ))


